<?php
defined('LOOTY') or die('direct access to this file is not allowed');

// links array
// This is an array of the different locale names that contains an array of links
// to various internet sites to populate the right hand side of the looty table
// the key is used as the display name, and the value a url.
// the following strings are substituted in the url:
//  @@@STRING@@@ : URL escaped string containing the item name
//  @@@ID@@@     : the numerical in game ID of the item
//  @@@LOCALE@@@ : the locale string
$links = array( 
  'enUS' => array (
    'thottbot'    => "http://www.thottbot.com/?i=@@@STRING@@@",
    'allakhazam'  => "http://wow.allakhazam.com/db/item.html?witem=@@@ID@@@&amp;locale=@@@LOCALE@@@",
    'wowhead'     => "http://www.wowhead.com/?item=@@@ID@@@",
  ),
  'deDE' => array (
    'allakhazam'  => "http://wow.allakhazam.com/db/item.html?witem=@@@ID@@@&amp;locale=@@@LOCALE@@@",
    'wowhandwerk' => "http://wowhandwerk.onlinewelten.com/item.php?id=@@@ID@@@",
  ),
  'frFR' => array (
    'allakhazam'  => "http://wow.allakhazam.com/db/item.html?witem=@@@ID@@@&amp;locale=@@@LOCALE@@@",
// reported as being down
//    'WoWDBU-FR'   => "http://fr.wowdbu.com/index.php?m=3&cat=7&pattern=@@@STRING@@@",
    'judgehype'   => "http://worldofwarcraft.judgehype.com/index.php?page=bc-obj&amp;w=@@@ID@@@",
  ),
);

// localisation table
$localised_strings = array(
  'enUS'  => array (
    'soulbound'  => 'Soulbound',
    'questitem'  => 'Quest Item',
    'requires'   => 'Requires',
    'equip'      => 'Equip',
    'use'        => 'Use',
    'lvlreq'     => '/Requires Level (\d+)/',
    'common'     => 'common',
    'uncommon'   => 'uncommon',    
    'superior'   => 'superior',
    'epic'       => 'epic',
    'legendary'  => 'legendary',
  ),
  'deDE'  => array (
    'soulbound'  => 'Seelengebunden',
    'questitem'  => 'Questgegenstand',
    'requires'   => 'Benötigt',
    'equip'      => 'Anlegen',
    'use'        => 'Benutzen',
    'lvlreq'     => '/Benötigt Stufe (\d+)/',
    'common'     => 'common',
    'uncommon'   => 'uncommon',    
    'superior'   => 'superior',
    'epic'       => 'epic',
    'legendary'  => 'legendary',
  ),
  // The french localisation is based upon the great work done by Frigolet 
  'frFR'  => array (
    'soulbound'          => 'Fragment',
    'questitem'          => 'Objet de',
    'requires'           => 'Requiert',
    'equip'              => 'Equipé',
    'use'                => 'Utiliser',
    'lvlreq'             => '/Niveau (\d+) requis/',
    'common'             => 'commum',
    'uncommon'           => 'pas commum',    
    'superior'           => 'supérieur',
    'epic'               => 'épic',
    'legendary'          => 'fabuleux',
    'Search for an item' => 'Chercher un item',
    '@@1@@ Guild Bank'   => 'Banque de Guilde : @@1@@',
    'any quality'        => 'Toute qualité',
    'min&nbsp;level:'    => 'Niveau&nbsp;min:',
    'max&nbsp;level:'    => 'Niveau&nbsp;max:',
    'item'               => 'item',
    'items'              => 'items',
    'expand'             => 'étendre',
    'collapse'           => 'réduire',
    'balance for @@1@@:' => 'Solde pour @@1@@',
    'overall balance:'   => 'Solde global',
    'item name'          => 'Item',
    'quantity'           => 'Quantité',
    'List of items currently held in the guild bank for @@1@@ of the @@2@@ realm.'  
      => 'Liste des items actuellement en banque pour la guilde @@1@@ du serveur @@2@@.',
    'Below is listed the contents of the guild bank for <b>@@1@@</b>.'
      => 'Ci-dessous le contenu des mules de la guilde : <b>@@1@@</b>',
    'Please contact <b>@@1@@</b> with any questions.'  
      => 'Pour toute transaction ou question envoyez un message par la boite aux lettres de @@1@@',
    'No items found for @@1@@' 
      => 'Aucun item trouvé pour @@1@@',
    'Matching items held by <b>@@1@@</b>' 
      => 'Items de <b>@@1@@</b>',
    'Matching all items in the guild bank'  
      => 'Tous les items de la banque',
    'Search for an item or list by category:' 
      => 'Chercher un item ou lister par catégorie :',
    'list all items in the bank' 
      => 'Tous les items',
    '(Last updated at @@1@@)'  
      => 'au: @@1@@',


  ),
);



?>