<?php
/*
  Looty - a Guild Bank Interface
  ==============================
*/

// set the error reporting level to avoid silly notices about unset variables etc.
error_reporting(E_ALL ^ E_NOTICE);
//error_reporting(E_ALL);

// define the constant that we check in included files
define("LOOTY", "ok");

// few basic settings about this verison of Looty
$lootycredits	= 'By Fin (fin@instinct.org) @ Stormrage EU, Maintained by Trell (djb@ragnarok.net) @ Runetotem EU';
$lootyver	= '1.2RC3';
$lootydate	= '2007-01-11';

// Rather than importing all request variables into the global scope
// we instead explicitly list all of the variables that we place into 
// global scope. This, on servers with register globals set to off
// ensures that you are unable to subvert any variables - trell
$filter      = $_REQUEST['filter'];
$expand      = $_REQUEST['expand'];
$charchooser = $_REQUEST['charchooser'];
$itemclass   = $_REQUEST['itemclass'];
$minlevel    = $_REQUEST['minlevel'];
$maxlevel    = $_REQUEST['maxlevel'];
$char        = $_REQUEST['char'];
$debug       = $_REQUEST['debug'];
$sort        = $_REQUEST['sort'];    // sort type (not implemented)
$oldsort     = $_REQUEST['oldsort']; // last sort type (not implemented)
$desc        = $_REQUEST['desc'];    // descending sort 

// set defaults. these are over-ridden in the config.php
$locale          = 'enUS';
$tipsfollowmouse = 0;
$showlastupdatetime = 1;
$not_localised = array(); // an array to contain strings which have not been localised

// get the config
include './config.php';
include './bits/localisation.php';

// setup locale shortcut
$L = $localised_strings[$locale];

// test to see if debugging is allowed
if ($allowdebug != 0 & $debug == 'yes') {
  $debug = 'yes';
} else {
  unset($debug);
}

// connect to the db
include './bits/dbsetup.php';

// init some vars
$tdclasses = array(
	'item',
	'itemlight',
);

$itemclasses = array(
	'#ffffff' => 'common',
	'#1eff00' => 'uncommon',
	'#0070dd' => 'superior',
	'#a335ee' => 'epic',
	'#d17c22' => 'legendary',
);

$itemclassindex = array_flip($itemclasses);

if ($itemclass)
	$itemclass = $itemclassindex[$itemclass];

$money = array(
	'gold'		=> 0,
	'silver'	=> 0,
	'copper'	=> 0,
);

if (!isset($expand) && $longdisplay == 1) {
	$expand	= 'expand';
} 

$guildname		= htmlspecialchars($guildname);
$guildname_plain	= $guildname;
$guildmaster		= htmlspecialchars($guildmaster);
$guildserver		= htmlspecialchars($guildserver);

if ($guildurl)
	$guildname = "<a href='$guildurl'>$guildname</a>";

if (!empty($bankchars)) {
	foreach ($bankchars as $tmpchar => $tmpdesc) {
		if (!$bankchars[$tmpchar]) {
			unset($bankchars[$tmpchar]);
		}
	}
}

if ($bankchar && empty($bankchars)) {
	$bankchars = array(
		$bankchar	=> 'Guild Bank',
	);
}

if (!$bankchars) {
	$bankchars = array();
	die('No bank characters found - configure this setting in config.php');
}

$allchars = $bankchars;

// reset $char if using different case
foreach ($bankchars as $tmpchar => $tmpdesc) {
	if (strtoupper($char) == strtoupper($tmpchar)) {
		$char = $tmpchar;
	}
}

if ($char && $bankchars[$char]) {
	$tmpchar = $bankchars[$char];

	$bankchars = array(
		$char => $tmpchar,
	);
}

$numlootchars = count($allchars);

// get details of bank characters from the db
foreach ($bankchars as $tmpchar => $tmpdesc) {
	$quotedchars[]	= "'" . addslashes(strtoupper($tmpchar)) . "'";
}

$player_sql	= "select * from {$dbprefix}players"
	. ' where upper(name) in (' . join(', ', $quotedchars) . ')';

$result	= mysql_query($player_sql); echo mysql_error();


// make sure we have some character data
if (!mysql_num_rows($result)) {
	die('Failed to get any player data from the database - check settings in config.php and whether CharacterProfiler is importing data correctly');
}


// make a list of member ids, names, and money
while ($player = mysql_fetch_array($result, MYSQL_ASSOC)) {
	$memberids[$player['name']]		= $player['member_id'];
	$membernames[$player['member_id']]	= $player['name'];

  $memberlastupdate[$player['name']]  = $player['dateupdatedutc'];
	$membermoney[$player['name']]['copper']	+= $player['money_c'];
	$membermoney[$player['name']]['silver']	+= $player['money_s'];
	$membermoney[$player['name']]['gold']	+= $player['money_g'];
}

foreach ($membernames as $tmpmemberid => $tmpmembername) {
	foreach ($bankchars as $tmpbankcharname => $tmpbankchardesc) {
		if (strtoupper($tmpmembername) == strtoupper($tmpbankcharname) && ($tmpmembername != $tmpbankcharname)) {
			$bankchars[$tmpmembername] = $tmpbankchardesc;

			unset($bankchars[$tmpbankcharname]);
		}
	}
}

// init the $wheres for the item select query
$wheres = array(
	"item_parent != 'bags'",
	'member_id in (' . join(', ', $memberids) . ')',
);

if ($hideequipped)
	$wheres[] = "item_parent != 'equip'";

if ($hidesoulbound)
	$wheres[] = "item_tooltip not like '%" . $L['soulbound'] . "%'";

if ($hidequest)
	$wheres[] = "item_tooltip not like '%" . $L['questitem'] . "%'";

if ($itemclass) {
	$tmpcolor = preg_replace('/^#/', '', $itemclass);
	$wheres[] = "(item_color = '$tmpcolor' or item_color = 'ff$tmpcolor')";
}

if ($filter) {
	// always escape data that has come in from the outside world. - trell
	if (get_magic_quotes_gpc()) {
		$filter = stripslashes($filter);
	}
	$safe_filter = mysql_real_escape_string($filter);
	$wheres[]	= $searchtips
			? "(item_name like '%$safe_filter%' or item_tooltip like '%$safe_filter%')"
			: "item_name like '%$safe_filter%'";
}

if (!isset($char))
	$char	= '';

if (isset($char)) {
	// set the default guild
	if (!$char)
		$guild	= '';

	// multi-guild stuff here a bit messy
	if ($guild && !empty($guildchars[$guild]))
		$bankcharnames = $guildchars[$guild];
	else
	// serves me right for starting something and dropping it halfway through
		$bankcharnames = array_keys($bankchars);

	foreach ($bankcharnames as $charname) {
		if ($memberids[$charname]) {
			$tmpmemberids[] = $memberids[$charname];

			$money['copper']	+= $membermoney[$charname]['copper'];
			$money['silver']	+= $membermoney[$charname]['silver'];
			$money['gold']		+= $membermoney[$charname]['gold'];
		}
	}


	$count	= 0;

	$item_sql	= "select * from {$dbprefix}items"
		. ($wheres ? ' where ' . join(' and ', $wheres) : '')
		. ($sort ? '' : ' order by item_name, member_id')
		;

	$result	= mysql_query($item_sql); echo mysql_error();

	while ($item = mysql_fetch_array($result, MYSQL_ASSOC)) {
		$index	= ++$count;

		$item['tooltip_orig']	= $item['item_tooltip'];

		if (preg_match($L['lvlreq'], $item['tooltip_orig'], $m))
			$item['level'] = $m[1];

		if ($minlevel && ($item['level'] < $minlevel))
			continue;

		if ($maxlevel && ($item['level'] > $maxlevel))
			continue;

		$item['index']		= $index;
		$item['name']	  	= $item['item_name'];
		$item['color']		= preg_replace((strlen($item['item_color']) == 8 ? '/^ff/' : '/^/'), '#', $item['item_color']);
		$item['class']		= $itemclasses[$item['color']];
		$item['amount']		= $item['item_quantity'];
		$item['player']		= $membernames[$item['member_id']];
		$item['icon']	  	= preg_replace('%\\\%', '/', $item['item_texture']);
		$item['htmlname']	= preg_replace('/ /', '&nbsp;', $item['name']);

		$item['tooltip']	= htmlspecialchars(stripslashes(trim($item['item_tooltip'])));
		$item['tooltip']	= preg_replace('/\s\n/', '&nbsp;', $item['tooltip']);
		$item['tooltip']	= trim(preg_replace("%(.+)\n%", "<span class='itemname {$item['class']}'>{$item['htmlname']}</span>\n\n", $item['tooltip'], 1));

		$item['tooltip']	= preg_replace('/\|cf(......).([^|]+?)\|r/', "\n<span style='color: #$1;'>$2</span>\n", $item['tooltip']);
		$item['tooltip']	= preg_replace('/(' . $L['requires'] . ')(.*)/', 
                          "\n<span class='requires'>\\1</span><span class='leveltext'>\\2</span>", 
		                      $item['tooltip']
		                    );
		$item['tooltip']	= preg_replace('/(' . $L['equip'] . '|' . $L['use'] . ')(.*)/', 
		                      "\n<span style='color: #1EFF00;'>$1$2</span>", 
		  $item['tooltip']
		);
		$item['tooltip']	= preg_replace('/\n{2,}/', "\n\n", $item['tooltip']);

    $item['id']         = explode(':', $item['item_id']);
    
		$item['info']		= preg_split('/\n/', $item['tooltip'], -1, PREG_SPLIT_NO_EMPTY & PREG_SPLIT_DELIM_CAPTURE);

		array_shift($item['info']);
		array_shift($item['info']);

		$item['tooltip']	= nl2br($item['tooltip']);
		$item['tooltip_len']	= strlen($item['tooltip']);

		if ($iconurlbase) {
			$iconurlbase	= preg_replace('%/+$%', '', $iconurlbase);
			$item['icon']	= "$iconurlbase/{$item['icon']}";
		}

		if (($existing = $itemnames[$item['name']]) && ($items[$existing]['player'] == $item['player'])) {
			$items[$existing]['amount'] += $item['amount'];
		} else {
			$itemnames[$item['name']] = $index;
			$items[$index] = $item;
		}
	}

	$total = count($items);

	if ($money['copper'] > 100) {
		$extrasilver		= floor($money['copper'] / 100);
		$money['silver']	+= $extrasilver;
		$money['copper']	-= 100 * $extrasilver;
	}

	if ($money['silver'] > 100) {
		$extragold		= floor($money['silver'] / 100);
		$money['gold']		+= $extragold;
		$money['silver']	-= 100 * $extragold;
	}
}

$oldsort = $sort;

if (!$desc && ($sort == $oldsort))
	$oldsort .= "&desc=1";

$items = sort_items($items, $sort, $desc);

$myurl = $_SERVER['PHP_SELF'];
$colspan = (((!$char && $guild) ? 5 : 4) + ($showicons ? 0 : 1));

require("./bits/display.php");

/* 
 * Follows are library calls from above
 */

function pre($var) { echo "<pre>DEBUG:\n"; print_r($var); echo '</pre>'; }

function init_sort($items, $field, $reverse) {
	uksort($items, create_function('$a, $b', 'if ($a == $b) return 0; return strcmp($a[\'' . $field . '\'], $b[\'' . $field . '\']);'));
	
	return $reverse ? array_reverse($items, true) : $items;
}

function sort_items($unsorted=array(), $sort='', $desc=false) {
	global $itemclasses;

	if (empty($unsorted))
		return array();

	$count = 0;

	foreach ($unsorted as $index => $item) {
		$sorted[$item['player']][++$count] = $item;
	}

	if ($sort) {
		// sort by given field
		foreach ($sorted as $char => $items) {
			$sorted[$char] = init_sort($items, $sort, $desc);
		}
	} else {
		// sort by class
		foreach ($sorted as $char => $items) {
			foreach ($items as $index => $item) {
				$tmpitems[$char][$item['class']][++$count] = $item;
			}
		}

		foreach ($tmpitems as $char => $itemsbyclass) {
			foreach ($itemclasses as $tmpclass) {
				if (empty($tmpitems[$char][$tmpclass]))
					continue;

				foreach ($tmpitems[$char][$tmpclass] as $newitem) {
					$tmpsorted[$char][++$count] = $newitem;
				}
			}
		}

		$sorted = $tmpsorted;
	}

	return $sorted;
}

function get_relative_url($expand_text='') {
  return $_SERVER['PHP_SELF'] . '?' . get_url_params($expand_text);
}

function get_url_params($expand_text='') {
  global $minlevel, $maxlevel, $oldsort, $char, $itemclasses, $expand, $debug, $sort;
   $url_bits = array();

    $minlevel  ? array_push($url_bits, "minlevel="  . $minlevel)  : '';
    $maxlevel  ? array_push($url_bits, "maxlevel="  . $maxlevel)  : '';
    $debug     ? array_push($url_bits, "debug="     . $debug)     : '';
    $char      ? array_push($url_bits, "char="      . $char)      : '';
    $itemclass ? array_push($url_bits, "itemclass=" . $itemclass) : '';
    $filter    ? array_push($url_bits, "filter="    . $filter)    : '';
    
    if (isset($expand_text)) {
      array_push($url_bits, "expand=" . $expand_text);
    }
    return implode('&amp;', $url_bits);
}

function generate_item_links($locale, $item_id, $item_name) {
  global $links;
  $urls = array();
  foreach ($links[$locale] as $link_name => $link) {
    $link = preg_replace('/@@@LOCALE@@@/', urlencode($locale),     $link);
    $link = preg_replace('/@@@ID@@@/',     urlencode($item_id),    $link);
    $link = preg_replace('/@@@STRING@@@/', urlencode($item_name),  $link);
    
    $urls[$link_name] = '<a href="' . $link . '" target="_blank">' 
     . $link_name . '</a>';
  }
  
  return $urls;
}

function pretty_url_list($locale, $item_id, $item_name) {
  $urls = generate_item_links($locale, $item_id, $item_name);
  
  $url_string  = "[&nbsp;";
  $url_string .= implode("&nbsp;|&nbsp;", $urls);
  $url_string .= "&nbsp;]";
  return $url_string;
}

function display_debug_vars() {
  global $player_sql, $item_sql, $expand, $char, $guild, $not_localised, $L, $locale;
  pre("guild: $guild");
  pre("char: $char");
  pre("expand: $expand");
  pre("long display: $longdisplay");
  pre("url string: " . get_relative_url());
  pre("item sql: $item_sql");
  pre("player sql: $player_sql");
  
  if ($not_localised) {
    print "<pre>please add localisations for the following to the $locale locale:\n";
    foreach ($not_localised as $string) {
      $string = htmlspecialchars($string);
      print " '$string'  => '',\n";
    }
    print "\n\nthe localisation table has the following entries:\n";
    print_r($L);
  }
}

function get_last_update_time($name) {
  global $memberlastupdate;
  
  $update_date = $memberlastupdate[$name];
  
  if (! $update_date) return "unknown";
  
  return $update_date;
  
}

function localise() {
  global $locale, $L, $not_localised;
  
  $num_args = func_num_args();
  $args     = func_get_args();

  $string   = $args[0]; // string is the first argument passed
  unset($args[0]);      // remove element 0 from array
  
  # get the localised string
  if ($locale != 'enUS') {
    if (isset($L[$string])) {
      $string = $L[$string];
    } else {
      array_push($not_localised, $string);
    }
  }

  foreach ($args as $key => $value) {
    # for each argument given, replace the @@$key@@ with the value passed in
    $string = preg_replace("/@@$key@@/", $value, $string);
  }
  
  return $string;  
}

?>